function res = calc_residue_vect(vX, vY, x_s, y_s, k0, Er_d, Er_u, sComp, oIm, oPole, bvDown, bv)
vStep = bvDown.*oPole.vStep_d(bv) + oPole.vStep_u(bv).*~bvDown;
k_plsmin = k0*(bvDown.*sqrt(Er_d)+ ~bvDown.*sqrt(Er_u));
vGamma = bvDown.*oPole.vGamma_d(bv) + ~bvDown.*oPole.vGamma_u(bv);
vSing = bvDown.*oPole.vSing_d(bv) + ~bvDown.*oPole.vSing_u(bv);
k_pole = oPole.k_pole;
t_pole = (1./vStep.*(k_pole./k_plsmin-1));

bMSource = 1;
bvDense = bvDown & (Er_d > Er_u) | ~bvDown & (Er_d < Er_u);
bvOnRight = ~bvDense;

isImpDn = 1;
isImpTh = 0;

bDiD = Er_d > Er_u;
isImproper_d = isImpDn*bDiD + isImpTh*~bDiD;
isImproper_u = isImpTh*bDiD + isImpDn*~bDiD;
% because k_pole is real, and we want the square-root to be continuous with
% its value below in the fourth quadrant, we must do the following:
isImproper_d = ~isImproper_d;
isImproper_u = ~isImproper_u;
nXY = length(vX(bv));
oPath.kx = repmat(k_pole,nXY,1);
oPath.ky_d = repmat(calc_kc(k0, k_pole, Er_d, isImproper_d),nXY,1);
oPath.ky_u = repmat(calc_kc(k0, k_pole, Er_u, isImproper_u),nXY,1);
oPath.bv = bv;
field_regular = integrand_vect(oPath, vX, vY, x_s, y_s, k0, Er_d, Er_u, sComp, bMSource, oIm);
bvSign = bvOnRight+~bvOnRight*(-1);
res = bvSign.*exp(+vGamma.*t_pole)./t_pole.^vSing.*field_regular./vStep./k_plsmin;

