function s = sdp(x, y, x_s, y_s, kc_d, kc_u)
bDenseIsDown = kc_d > kc_u;
kc_th = kc_u*bDenseIsDown + kc_d*~bDenseIsDown;
isImpDn = 1; % these are only used to calc the error
isImpTh = 0; 
isImpD = bDenseIsDown*isImpDn + ~bDenseIsDown*isImpTh;
isImpU = ~bDenseIsDown*isImpDn + bDenseIsDown*isImpTh;
bRef = y <= 0;
s = zeros(length(y),2);
s(bRef) = kc_d*abs(x(bRef)-x_s)./sqrt((x(bRef)-x_s).^2+(y(bRef)+y_s).^2);

if any(~bRef)
    a = abs(x-x_s);
    b = abs(y);
    c = abs(y_s);
    a = a(:);
    c = c(:);
    a = a(~bRef);
    b = b(~bRef);
    eps_r = (kc_d/kc_u)^2;
%    A(:,1) = (4.*b.^2.*c.^2-(a.^2+b.^2+c.^2).^2);
%    A(:,2) = (-2.*(-a.^2.*kc_d.^2-a.^2.*kc_u.^2-b.^2.*kc_u.^2-c.^2.*kc_d.^2).*(a.^2+b.^2+c.^2)-4.*b.^2.*c.^2.*kc_d.^2-4.*b.^2.*c.^2.*kc_u.^2);
%    A(:,3) = (-2.*a.^2.*kc_d.^2.*kc_u.^2.*(a.^2+b.^2+c.^2)-(-a.^2.*kc_d.^2-a.^2.*kc_u.^2-b.^2.*kc_u.^2-c.^2.*kc_d.^2).^2+4.*b.^2.*c.^2.*kc_d.^2.*kc_u.^2);
%    A(:,4) = -2.*a.^2.*kc_d.^2.*kc_u.^2.*(-a.^2.*kc_d.^2-a.^2.*kc_u.^2-b.^2.*kc_u.^2-c.^2.*kc_d.^2);
%    A(:,5) = -a.^4.*kc_d.^4.*kc_u.^4;
    A(:,1) = 2.*a.^2.*c.^2+2.*b.^2.*a.^2-2.*b.^2.*c.^2+a.^4+c.^4+b.^4;
    A(:,2) = -2.*eps_r.*a.^4-2.*a.^2.*c.^2.*eps_r-4.*b.^2.*eps_r.*a.^2-2.*a.^4-4.*a.^2.*c.^2-2.*b.^2.*a.^2-2.*c.^4+2.*b.^2.*c.^2+2.*eps_r.*b.^2.*c.^2-2.*eps_r.*b.^4;
    A(:,3) = 4.*eps_r.*a.^4+4.*a.^2.*c.^2.*eps_r+4.*b.^2.*eps_r.*a.^2+a.^4.*eps_r.^2+2.*b.^2.*eps_r.^2.*a.^2+a.^4+2.*a.^2.*c.^2+c.^4-2.*eps_r.*b.^2.*c.^2+eps_r.^2.*b.^4;
    A(:,4) = -2.*a.^4.*eps_r.^2-2.*eps_r.*a.^4-2.*a.^2.*c.^2.*eps_r-2.*b.^2.*eps_r.^2.*a.^2;
    A(:,5) = a.^4.*eps_r.^2;
    alpha2 = roots_loop(A);
    % make sure there is at least one real root between the origin and
    % kc_th
    kx = sqrt(alpha2)*kc_u;
    [dummy, iMin] = min(abs(imag(kx)));
    kx(iMin) = real(kx(iMin));

    a = repmat(a, 1, 4);
    b = repmat(b, 1, 4);
    err = abs(a + b.*ky_diff(kc_u, kx, isImpU) + c.*ky_diff(kc_d, kx, isImpD));
    nX = sum(~bRef);
    kx_tran = zeros(nX, 2);
    for iX = 1:nX
        vKx = kx(iX, :);
        bReal = (real(vKx) >= 0) & (real(vKx) <= kc_th) & (abs(imag(vKx)) <= abs(real(vKx))/1e7);
        if sum(bReal) == 0 % this happens when sdp is very close to kc_th
            kx_tran(iX, 1) = kc_th;
        else
            kx_real = real(vKx(bReal));
            err_real = err(iX, bReal);
            [dummy, iS] = min(err_real);
            kx_tran(iX, 1) = kx_real(iS);
        end
        bComp = real(vKx)>0 & imag(vKx)<0;
        if ~any(bComp)
            bComp = ~bReal;
        end
        if any(bComp)
            kx_comp = vKx(bComp);
            err_comp = err(iX, bComp);
            [dummy, iS] = min(err_comp);
            kx_tran(iX, 2) = kx_comp(iS);
        else
            kx_tran(iX, 2) = kx_tran(iX,1); % only real SPs
        end
    end
    s(~bRef,:) = kx_tran;
end
    function out = ky_diff(kc, kx, isImp)
        bReal = abs(imag(kx)) <= abs(real(kx))*eps;
        kx(bReal) = kx(bReal)*(1+j*eps);
        [rows, cols] = size(kx);
        isImp = repmat(isImp, rows, cols);
        isImp(bReal) = 0;
        out = -kx./calc_kc(kc, kx, 1, isImp);
    end
end