function [sm_path, jac] = smooth_path_vect_LS(x, y, t, xi, vMax, vX0)
mMax = repmat(vMax, 1, size(xi,2));
if nargin == 5
    bOffset = 0;
    xi = xi./vMax(1);
else
    bOffset = 1;
    xi = [0 xi]./vMax(1);
end
order = max(min(round(length(t)/2),20),5);
%order = max(round(length(t)/2),5);
%order = 20;
t = t/vMax(1);

p = polyfir(t, x+j*y, order);
d = repmat(order:-1:1, length(vMax), 1);
dp = p(:,1:end-1).*d;
sm_path = polyvar(p, xi);
if bOffset
    offset = sm_path(:,1);
    sm_path = sm_path(:,2:end)-repmat(offset-vX0, 1, length(xi)-1);
    xi = xi(2:end);
end
jac = polyvar(dp, xi)./mMax;



